/*********************************************************
 * filter.h
 *
 * Copyright (c) Stefan Hellkvist
 *********************************************************/

#ifndef FILTER_H
#define FILTER_H

#include "pattern.h"

/*
 * sizeNormFilter: Normalizes the size of the pattern to a 100x100-square
 */
Pattern FAR *sizeNormFilter( Pattern FAR *p );

/*
 * pointDistanceNormFilter: Reduces unnessesary points, removing
 * points that are too close together.
 */
Pattern FAR *pointDistanceNormFilter( Pattern FAR *p );

/*
 * smoothFilter: Using averaging to reduce the amount of digitizing errors
 */ 
Pattern FAR *smoothFilter( Pattern FAR *p );


/*ce
* antiSlantedFilter corrects slanted Patterns to straight ones
*/
Pattern FAR *antiSlantedFilter( Pattern FAR *p );

void setSlantedFilterStrength(int s);

#endif
