#ifndef PREPROCESSOR_H
#define PREPROCESSOR_H

#include "pattern.h"

typedef Pattern FAR * (*filter) ( Pattern FAR * );

struct preprocessor
{
    filter *fs;
    int nFilters;
};
typedef struct preprocessor Preprocessor;

/* Creates a new preprocessor with nFilters filters */
Preprocessor FAR *newPreprocessor( filter *fs, int nFilters );

/* Destroys a preprocessor */
void deletePreprocessor( Preprocessor FAR *p );

/*
 * Applies a preprocessor to a pattern, generating a new pattern
 * The old pattern is not destroyed.
 */
Pattern FAR *apply( Preprocessor FAR *p, Pattern FAR *pat );

#endif
